using System;
using System.Collections.Specialized;
using System.IO;
using System.Net;
using System.Text;

namespace WiRNS
{
  public class MySoftwareUpdate
  {
    private static int CAP_HANDLES_GET = 2;

    private static int VERSION_HANDLES_HTTP11 = 11;


    public int GetHTTPCapabilities()
    {
      return CAP_HANDLES_GET;
    }

    public int GetHTTPVersion()
    {
      return VERSION_HANDLES_HTTP11;
    }

    public string[] GetHTTPRequests()
    {
      return new string[]{"/cgi-bin/2.0/getsw.pl"};
    }

    public void SetRNSIP(string rnsip)
    {
    }

    public void SetRNSPort(int rnsport)
    {
    }

    public void SetDelimeter(string delimeter)
    {
    }

    public void SetDBDSN(string dsn)
    {
    }

    public byte[] HandleMessage(string message, byte[] data)
    {
      try
      {
        message.Split(new char[]{'\n'});
        byte[] bs1 = new byte[0];
        Console.WriteLine("[PLUGIN] MySoftwareUpdate initialized.");
        string str1 = ReadFile("swupdate");
        if (str1 != null)
        {
          Console.WriteLine("[PLUGIN] MySoftwareUpdate using swupdate from file.");
          string str2 = String.Format("{0:r}", DateTime.Now);
          string str3 = String.Concat(new object[]{"HTTP/1.1 200 OK\r\nDate: ", str2, "\r\nServer: Apache/1.3.20 (Unix) mod_perl/1.26\r\nContent-Length: ", str1.Length, "\r\nContent-Type: text/plain\r\n\r\n"});
          bs1 = new ASCIIEncoding().GetBytes(String.Concat(str3, str1));
          Console.WriteLine("[PLUGIN] MySoftwareUpdate renamed 'swupdate' to 'swupdate.done'.");
          File.Move("swupdate","swupdate.done");
        }
        else
        {
          Console.WriteLine("[PLUGIN] MySoftwareUpdate - 'swupdate' file not found.  Blocking getsw.pl attempts.");
        }
        byte[] bs2 = bs1;
        return bs2;
      }
      catch (Exception e)
      {
        Console.WriteLine(e);
        return Encoding.Default.GetBytes("HTTP/1.1 500 ERROR\r\n\r\n");
      }
    }

    protected byte[] GrowArray(byte[] array, int size)
    {
      byte[] bs = new byte[(int)array.Length + size];
      Array.Copy(array, bs, (int)array.Length);
      return bs;
    }

    private bool gotContent(int contentLength, string message)
    {
      if (message.IndexOf("\r\n\r\n") <= 0)
      {
        return false;
      }
      int i = message.IndexOf("\r\n\r\n") + 4;
      if (message.Length - contentLength == i)
      {
        return true;
      }
      else
      {
        return false;
      }
    }

    private int getContentLength(string message)
    {
      string str;

      if (message.IndexOf("Content-Length:") <= 0)
      {
        return 0;
      }
      StringReader stringReader = new StringReader(message);
      for (str = stringReader.ReadLine(); str != null && !str.StartsWith("Content-Length:"); str = stringReader.ReadLine())
      {
      }
      if (str != null)
      {
        return Int32.Parse(str.Substring(15, str.Length - 15).Trim());
      }
      Console.WriteLine("Missing Content Length!");
      return 0;
    }

    private static string ReadFile(string filename)
    {
      string str;

      try
      {
        FileStream fileStream = new FileStream(filename, FileMode.Open, FileAccess.Read);
        str = new StreamReader(fileStream, Encoding.ASCII).ReadToEnd();
        fileStream.Close();
      }
      catch (Exception)
      {
        str = null;
      }
      return str;
    }
  }

}
